﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UltraGridBindingHyerarchicalTables
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        private void LoadDataGrid()
        {
            DataTable dt1 = new DataTable();
            dt1.Columns.Add("ParentId", typeof(int));
            dt1.Columns.Add("Description", typeof(string));
            dt1.Columns.Add("Comments", typeof(string));

            DataTable dt2 = new DataTable();
            dt2.Columns.Add("ChildId", typeof(int));
            dt2.Columns.Add("Description", typeof(string));
            dt2.Columns.Add("Comments", typeof(string));
            dt2.Columns.Add("Delete", typeof(string));

            dt1.Rows.Add(101, "Parent Description 1", "Parent Comments");
            dt2.Rows.Add(101, "Child Description 1", "Child Comments1");
            dt2.Rows.Add(101, "Child Description 2", "Child Comments2");


            DataSet ds = new DataSet();
            ds.Tables.Add(dt1);
            ds.Tables.Add(dt2);

            DataRelation dr1 = new DataRelation("DR1", dt1.Columns[0], dt2.Columns[0], false);

            ds.Relations.Add(dr1);

            ultraGrid1.DataSource = ds;
            ultraGrid1.DisplayLayout.Bands[1].ColHeadersVisible = false;
            ultraGrid1.DisplayLayout.Bands[1].Columns["Delete"].MaxWidth = 20;// dont wont to extends this column as it is last column in bands[1]
            ultraGrid1.DisplayLayout.Bands[1].Columns["Delete"].MinWidth = 20;
            ultraGrid1.DisplayLayout.Bands[1].Columns["Delete"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            ultraGrid1.DisplayLayout.Bands[1].Columns["Delete"].CellAppearance.Image = UltraGridBindingHyerarchicalTables.Properties.Resources.delete;

            ultraGrid1.Rows[0].ExpandAll();

            ultraGrid1.DisplayLayout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ExtendLastColumn;
            //below line is not working
            //width of ChildComments column should be equal to ParentComments column -20 (20 is the width of delete column)
            ultraGrid1.DisplayLayout.Bands[1].Columns["Comments"].Width = ultraGrid1.DisplayLayout.Bands[0].Columns["Comments"].CellSizeResolved.Width - 20;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            LoadDataGrid();
        }

    }
}

